#include "iwf_table_creation.h"


extern vtc_lte_trsw_config_table_t         * Strsw_config_table;
extern sicp_lte_ip_data_t                  * sicp_lte_ip;
extern uint8_t                             trsw_config_table_place[MAX_SGW_IP_ADDRESSES];
uint8_t                                    trswConfigTable_size = 0;
#ifdef __PATH_SUPERV_ENABLE__
bool                                       gtp_path_mgmt_superv_enable = false;
#endif
extern unsigned int iwf_log_level; 

uint32_t getUserPathIpIndex (iwf_ip_addr_t *  trsUpIp)
{
    uint32_t index = 0;
    for (index = 0; index < LTE_MAX_IP_SRC_IDX; index++)
    {
        if (ip_is_equal(trsUpIp,&sicp_lte_ip[index].uip_src))

        {
            return index;
        }
    }

    return LTE_IP_SRC_IDX_INVALID;
}
#ifdef __PATH_SUPERV_ENABLE__
uint32_t ipcs_gtp_path_mgmt_superv_enable(bool mode)
{
    //printk("\n ipcs_gtp_path_mgmt_superv_enable is invoked");
    gtp_path_mgmt_superv_enable = mode;
    return VTC_OK;
}
#endif

int set_gtp_mgmt_trswConfigTable (uint16_t rx_nid,  uint16_t tx_nid,
        uint16_t rx_cpid, uint16_t tx_cpid,
        iwf_ip_addr_t * ip_dst,iwf_ip_addr_t * ip_src)
{
    uint8_t  i = 0;
    uint8_t  old_entry_flag = 0;
    uint32_t index = LTE_IP_SRC_IDX_INVALID;
    if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
    {
        if(0 != printk_ratelimit())
        {
            printk ("TRSCONFIG DEBUG:In the core function set_gtp_mgmt_trswConfigTable\n");
        }
    }

    /* check to validate the input parameters */
    if((rx_nid == 0) || (tx_nid == 0) || (rx_cpid == 0) || (tx_cpid == 0) ||
            is_ip_addr_null(ip_dst) || is_ip_addr_null(ip_src))
    {
        /*printk("SE_TRACE: Invalid Configuration Received: rx_nid(0x%x), tx_nid(0x%x), rx_cpid(0x%x), tx_cpid(0x%x), ip_dst(0x%0x), ip_src(0x%x)\n",
          rx_nid, tx_nid, rx_cpid, tx_cpid, ip_dst, ip_src);*/

        return ERR_INVALID_CONFIGURATION;
    }

    /* get index from ip_src */
    index  = getUserPathIpIndex(ip_src);
    if(LTE_IP_SRC_IDX_INVALID == index)
    {
        return ERR_INVALID_INDEX_IN_LTE_IP_TABLE;
    }

    if(trswConfigTable_size > (MAX_SGW_IP_ADDRESSES - 1))
    {
        for(i=0; i<MAX_SGW_IP_ADDRESSES; i++)
        {
            if(trsw_config_table_place[i] == GTPU_TRSW_FREE)
            {
                trswConfigTable_size = i;
                old_entry_flag = 1;
                goto write_table;
            }
        }
        if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
        {
            if(0 != printk_ratelimit())
            {

                printk("TRSCONFIG DEBUG: maximum entries reached\n");
            }
        }
        return ERR_GTP_MGMT_TRSW_CONFIG_TABLE_FULL;
    }
    else
    {
write_table:

        //Check if table was initialized and the place to be written is "free"
        /*the check changed as a part of LTE505 */
        if ((Strsw_config_table[trswConfigTable_size].rx_nid != 0)  || 
                (Strsw_config_table[trswConfigTable_size].tx_nid != 0)  ||
                (Strsw_config_table[trswConfigTable_size].rx_cpid != 0) ||
                (Strsw_config_table[trswConfigTable_size].tx_cpid != 0) ||
                (Strsw_config_table[trswConfigTable_size].ip_src_index != LTE_IP_SRC_IDX_INVALID ) || 
                (!is_ip_addr_null(&Strsw_config_table[trswConfigTable_size].uip_dst))||
                (!is_ip_addr_null(&Strsw_config_table[trswConfigTable_size].uip_src)))
        {
            if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
            {
                if(0 != printk_ratelimit())
                {

                    printk("TRSCONFIG DEBUG: existing entry, please use the modify command\n");
                }
            }

            return ERR_ENTRY_EXIST_IN_GTP_MGMT_TRSW_CONF_TABLE; 
        }
        else
        {
            //Same entry already available?
            for(i=0; i<MAX_SGW_IP_ADDRESSES; i++)
            {
                if ((Strsw_config_table[i].rx_nid == rx_nid) &&
                        (Strsw_config_table[i].tx_nid == tx_nid) &&
                        (Strsw_config_table[i].rx_cpid == rx_cpid) &&
                        (Strsw_config_table[i].tx_cpid == tx_cpid) &&
                        (ip_is_equal(&Strsw_config_table[trswConfigTable_size].uip_dst,ip_dst)) &&
                        (Strsw_config_table[i].ip_src_index == index) &&
                        (ip_is_equal(&Strsw_config_table[trswConfigTable_size].uip_src,ip_src)))
                {
                    if(IWF_LOG_LEVEL_DL_SUCC_ALL_LOG & iwf_log_level)
                    {
                        if(0 != printk_ratelimit())
                        {

                            printk("TRSCONFIG DEBUG: connection already exists\n");
                        }
                    }
                    return ERR_CONN_EXIST_IN_GTP_MGMT_TRSW_CONF_TABLE;
                }
            }

            if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
            {
                if(0 != printk_ratelimit())
                {

                    printk("TRSCONFIG DEBUG: data received:\n");
                    printk("TRSCONFIG DEBUG:rx_nid = 0x%x, tx_nid = 0x%x, rx_cpid = 0x%x, tx_cpid = 0x%x, ip_src_index = 0x%x\n",
                            rx_nid, tx_nid,
                            rx_cpid, tx_cpid,
                            index);
                }
            }

            Strsw_config_table[trswConfigTable_size].rx_nid  = rx_nid;
            Strsw_config_table[trswConfigTable_size].tx_nid  = tx_nid;
            Strsw_config_table[trswConfigTable_size].rx_cpid = rx_cpid;
            Strsw_config_table[trswConfigTable_size].tx_cpid = tx_cpid;
            Strsw_config_table[trswConfigTable_size].ip_src_index = index;
            if(ip_dst->version == IPv4)
            {
                Strsw_config_table[trswConfigTable_size].uip_dst.addr_u.ipv4Address.ipa_32 = ip_dst->addr_u.ipv4Address.ipa_32;
                Strsw_config_table[trswConfigTable_size].uip_dst.version = ip_dst->version;
                Strsw_config_table[trswConfigTable_size].uip_src.addr_u.ipv4Address.ipa_32 = ip_src->addr_u.ipv4Address.ipa_32;
                Strsw_config_table[trswConfigTable_size].uip_src.version = ip_src->version;
                if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
                {
                    if(0 != printk_ratelimit())
                    {
                        printk("TRSCONFIG DEBUG:ip_dest= 0x%x,version %d,ip_src =0x%x",Strsw_config_table[trswConfigTable_size].uip_dst.ip4_addr32,
                                Strsw_config_table[trswConfigTable_size].uip_dst.version,
                                Strsw_config_table[trswConfigTable_size].uip_dst.ip4_addr32);
                    }
                }
            }
            else
            {
                Strsw_config_table[trswConfigTable_size].uip_dst.addr_u.ipv6Address.ipa_32[0]=ip_dst->addr_u.ipv6Address.ipa_32[0];
                Strsw_config_table[trswConfigTable_size].uip_dst.addr_u.ipv6Address.ipa_32[1]=ip_dst->addr_u.ipv6Address.ipa_32[1];
                Strsw_config_table[trswConfigTable_size].uip_dst.addr_u.ipv6Address.ipa_32[2]=ip_dst->addr_u.ipv6Address.ipa_32[2];
                Strsw_config_table[trswConfigTable_size].uip_dst.addr_u.ipv6Address.ipa_32[3]=ip_dst->addr_u.ipv6Address.ipa_32[3];
                Strsw_config_table[trswConfigTable_size].uip_src.addr_u.ipv6Address.ipa_32[0]=ip_src->addr_u.ipv6Address.ipa_32[0];
                Strsw_config_table[trswConfigTable_size].uip_src.addr_u.ipv6Address.ipa_32[1]=ip_src->addr_u.ipv6Address.ipa_32[1];
                Strsw_config_table[trswConfigTable_size].uip_src.addr_u.ipv6Address.ipa_32[2]=ip_src->addr_u.ipv6Address.ipa_32[2];
                Strsw_config_table[trswConfigTable_size].uip_src.addr_u.ipv6Address.ipa_32[3]=ip_src->addr_u.ipv6Address.ipa_32[3];
                Strsw_config_table[trswConfigTable_size].uip_dst.version = ip_dst->version;
                Strsw_config_table[trswConfigTable_size].uip_src.version = ip_src->version;
                if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
                {
                    if(0 != printk_ratelimit())
                    {
                        printk("TRSCONFIG DEBUG:ip_dest= 0x%x: 0x%x: 0x%x :0x%x,version %d,ip_src =0x%x:0x%x:0x%x:0x%x",
                                Strsw_config_table[trswConfigTable_size].uip_dst.addr_u.ipv6Address.ipa_32[0],Strsw_config_table[trswConfigTable_size].uip_dst.addr_u.ipv6Address.ipa_32[1],
                                Strsw_config_table[trswConfigTable_size].uip_dst.addr_u.ipv6Address.ipa_32[2],Strsw_config_table[trswConfigTable_size].uip_dst.addr_u.ipv6Address.ipa_32[3],
                                Strsw_config_table[trswConfigTable_size].uip_dst.version,
                                Strsw_config_table[trswConfigTable_size].uip_src.addr_u.ipv6Address.ipa_32[0],Strsw_config_table[trswConfigTable_size].uip_src.addr_u.ipv6Address.ipa_32[1],
                                Strsw_config_table[trswConfigTable_size].uip_src.addr_u.ipv6Address.ipa_32[2],Strsw_config_table[trswConfigTable_size].uip_src.addr_u.ipv6Address.ipa_32[3]);
                    }
                }


            }


            //printk("SE_TRACE: %d. entry:\n", (trswConfigTable_size+1));

            trsw_config_table_place[trswConfigTable_size] = GTPU_TRSW_USED;

            //Increment the table entry number
            if(old_entry_flag)
            {
                trswConfigTable_size = MAX_SGW_IP_ADDRESSES; //deleted table entry filled
            }
            else
            {
                trswConfigTable_size++; //table not fully filled
            }
        }
    }
    return VTC_OK;
}


uint32_t ipcs_set_gtp_mgmt_trswConfigTable (sIpSicpApiMsg *msg)
{
    ip_sicp_api_t       * cfg       = NULL;
    vtc_lte_trsw_config_table_t * conf_data = NULL;
    uint32_t              retVal    = VTC_OK;

    //printk ("ipcs_set_gtp_mgmt_trswConfigTable ......");

    cfg = (ip_sicp_api_t *) getCfgMsgPayload(msg);

    if(cfg)
    {
        conf_data = (vtc_lte_trsw_config_table_t *) &cfg->u.trsw_config_table;


        if(conf_data)
        {
            retVal = set_gtp_mgmt_trswConfigTable(conf_data->rx_nid, conf_data->tx_nid, conf_data->rx_cpid,
                    conf_data->tx_cpid, &conf_data->uip_dst, &conf_data->uip_src);
        }
        else
        {
            retVal = VTC_ERR;
        }
    }
    else
    {
        retVal = ERR_INVALID_CONFIGURATION;
    }

    return retVal;
}


int mod_gtp_mgmt_trswConfigTable (uint16_t rx_nid,  uint16_t tx_nid,
        uint16_t rx_cpid, uint16_t tx_cpid,
        iwf_ip_addr_t * ip_dst, iwf_ip_addr_t * ip_src)
{
    uint8_t  index    = 0;
    uint32_t ip_index = LTE_IP_SRC_IDX_INVALID;
    if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
    {
        if(0 != printk_ratelimit())
        {

            printk ("TRSCONFIG DEBUG: mod_gtp_mgmt_trswConfigTable ......");
        }
    }

    ip_index  = getUserPathIpIndex(ip_src);
    if(LTE_IP_SRC_IDX_INVALID == ip_index)
    {
        return ERR_INVALID_INDEX_IN_LTE_IP_TABLE;
    } 
    //Same entry already available?
    for(index=0; index<MAX_SGW_IP_ADDRESSES; index++)
    {
        if ((Strsw_config_table[index].rx_nid == rx_nid) &&
                (Strsw_config_table[index].tx_nid == tx_nid) &&
                (Strsw_config_table[index].rx_cpid == rx_cpid) &&
                (Strsw_config_table[index].tx_cpid == tx_cpid) &&
                ip_is_equal(&Strsw_config_table[index].uip_dst, ip_dst) &&
                (Strsw_config_table[index].ip_src_index == ip_index))
        {
            if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
            {
                if(0 != printk_ratelimit())
                {
                    printk("TRSCONFIG DEBUG: connection already exists\n");
                }
            }
            return ERR_CONN_EXIST_IN_GTP_MGMT_TRSW_CONF_TABLE;
        }
    }

    for(index=0; index<MAX_SGW_IP_ADDRESSES; index++)
    {

        //Check for IP address and corresponding CCID (CCID which was assigned by TRSW host)
        if(ip_is_equal(&Strsw_config_table[index].uip_dst, ip_dst) &&
                (Strsw_config_table[index].tx_cpid == tx_cpid) &&
                (Strsw_config_table[index].ip_src_index == ip_index) &&
                ip_is_equal(&Strsw_config_table[index].uip_src, ip_src))
        {
            if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
            {
                if(0 != printk_ratelimit())
                {
                    printk("TRSCONFIG DEBUG:entry found!\n");
                }
            }
            /*printk("rx_nid= 0x%x, tx_nid= 0x%x, rx_cpid= 0x%x, tx_cpid= 0x%x, ip_dest = 0x%x, ip_src = 0x%x\n",
              rx_nid, tx_nid,
              rx_cpid, tx_cpid,
              ip_src,
              ip_src);
             */		
            //Modify existing table entry (S-GW IP (ip_dst) and assigned CCID will not be changed!
            Strsw_config_table[index].rx_nid = rx_nid;
            Strsw_config_table[index].tx_nid = tx_nid;
            Strsw_config_table[index].rx_cpid = rx_cpid;

            if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
            {
                if(0 != printk_ratelimit())
                {
                    printk("TRSCONFIG DEBUG: modified entry #%d:\n", (index+1));
                    printk("rx_nid = 0x%x, tx_nid = 0x%x, rx_cpid = 0x%x, tx_cpid = 0x%x,ip_src_index= 0x%x\n",
                            Strsw_config_table[index].rx_nid,  Strsw_config_table[index].tx_nid,
                            Strsw_config_table[index].rx_cpid, Strsw_config_table[index].tx_cpid,
                            Strsw_config_table[index].ip_src_index); 
                }
            }
            break;
        }
    }
    if(index == MAX_SGW_IP_ADDRESSES)
    {
        if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
        {
            if(0 != printk_ratelimit())
            {

                printk("TRSCONFIG DEBUG: no matching entry found!\n");
            }
        }
        return ERR_NO_MATCHING_ENTRY;
    }
    else
    {
        return VTC_OK;
    }
}

iwf_ip_addr_t * get_sicp_lte_ip (uint8_t index)
{ 
    return &sicp_lte_ip[index].uip_src;
}
uint8_t get_teid_0_sicp_connection (iwf_ip_addr_t ip_src,iwf_ip_addr_t ip_dst)
{
    uint8_t i;

    for (i = 0; i < MAX_SGW_IP_ADDRESSES; i++)
    {

        //Search the CCID based on the received S-GW IP address (S-GW IP comes as source IP address)

        if(ip_is_equal(&ip_src,&Strsw_config_table[i].uip_dst)) 
        {
            iwf_ip_addr_t *temp_ip;
            if(IWF_LOG_LEVEL_DL_SUCC_ALL_LOG & iwf_log_level)
            {
                if(0 != printk_ratelimit())
                {

                    printk("TRSCONFIG DEBUG:SRC DST Match found\n");
                }
            }
            temp_ip = get_sicp_lte_ip(Strsw_config_table[i].ip_src_index);
            if ( ip_is_equal(temp_ip,&ip_dst))
            {
                if(IWF_LOG_LEVEL_DL_SUCC_ALL_LOG & iwf_log_level)
                {
                    if(0 != printk_ratelimit())
                    {

                        printk ("TRSCONFIG DEBUG:GTPU echo response: CCID found !!! \n");
                    }
                }
                return i;
            }
        }
    }
    return i;
}

//--------------------------------------------------------------------------------//
uint32_t ipcs_mod_gtp_mgmt_trswConfigTable (sIpSicpApiMsg *msg)
{
    ip_sicp_api_t       * cfg       = NULL;
    vtc_lte_trsw_config_table_t * conf_data = NULL;
    uint32_t              retVal    = VTC_OK;

    //printk ("in Function .... ipcs_mod_gtp_mgmt_trswConfigTable\n");
    cfg = (ip_sicp_api_t *) getCfgMsgPayload(msg);

    if (cfg)
    {
        conf_data = (vtc_lte_trsw_config_table_t *) &cfg->u.trsw_config_table;

        if (conf_data)
        {
            retVal = mod_gtp_mgmt_trswConfigTable(conf_data->rx_nid, conf_data->tx_nid, conf_data->rx_cpid,
                    conf_data->tx_cpid, &conf_data->uip_dst, &conf_data->uip_src);
        }
        else
        {
            retVal = VTC_ERR;
        }
    }
    else
    {
        retVal = ERR_INVALID_CONFIGURATION;
    }
    return retVal;
}

int del_gtp_mgmt_trswConfigTable (uint16_t tx_cpid, iwf_ip_addr_t * ip_dst, iwf_ip_addr_t * ip_src)
{
    uint8_t index = 0;
    if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
    {
        if(0 != printk_ratelimit())
        {

            printk("TRSCONFIG DEBUG: del_gtp_mgmt_trswConfigTable function called \n");
            printk("TRSCONFIG DEBUG: data received:\n");
            printk("tx_cpid: %d, ip_dst =%d, ip_src =%d\n",
                    tx_cpid,
                    ip_dst->version, ip_src->version);
        }
    }

    for(index=0; index<MAX_SGW_IP_ADDRESSES; index++)
    {
        //Check for IP address and corresponding CCID (CCID which was assigned by TRSW host)
        if ((ip_is_equal(&Strsw_config_table[index].uip_dst, ip_dst) &&
                    ip_is_equal(&Strsw_config_table[index].uip_src, ip_src)) &&
                (Strsw_config_table[index].tx_cpid == tx_cpid))
        {
            trsw_config_table_place[index] = GTPU_TRSW_FREE;

            //Delete existing table entry
            memset(&Strsw_config_table[index], 0, sizeof(vtc_lte_trsw_config_table_t));
            Strsw_config_table[index].ip_src_index      = LTE_IP_SRC_IDX_INVALID;

            /*printk("rx_nid = 0x%x, tx_nid = 0x%x, rx_cpid = 0x%x, tx_cpid = 0x%x, ip_dest = 0x%x, ip_src = 0x%x, ip_src_index = 0x%x\n",
              Strsw_config_table[index].rx_nid, 
              Strsw_config_table[index].tx_nid,
              Strsw_config_table[index].rx_cpid,
              Strsw_config_table[index].tx_cpid,
              Strsw_config_table[index].uip_dst.ip4_addr32,
              Strsw_config_table[index].uip_src.ip4_addr32,
              Strsw_config_table[index].ip_src_index); */
            break;
        }
    }

    if(index == MAX_SGW_IP_ADDRESSES)
    {
        if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
        {
            if(0 != printk_ratelimit())
            {

                printk("TRSCONFIG DEBUG: NO matching Entry found \n");
            }
        }
        return ERR_NO_MATCHING_ENTRY;
    }
    else
    {
        return VTC_OK;
    }
}

uint32_t ipcs_del_gtp_mgmt_trswConfigTable (sIpSicpApiMsg *msg)
{
    ip_sicp_api_t         * cfg       = NULL;
    vtc_lte_trsw_config_table_t   * conf_data = NULL;
    uint32_t                retVal    = VTC_OK;

    cfg = (ip_sicp_api_t *) getCfgMsgPayload(msg);

    if (cfg)
    {
        conf_data = (vtc_lte_trsw_config_table_t *) &cfg->u.trsw_config_table;

        if (conf_data)
        {
            retVal = del_gtp_mgmt_trswConfigTable(conf_data->tx_cpid, &conf_data->uip_dst, &conf_data->uip_src);
        }
        else
        {
            retVal = VTC_ERR;
        }
    }
    else
    {
        retVal = ERR_INVALID_CONFIGURATION;
    }

    return retVal;
}

uint32_t get_gtp_mgmt_trswConfigTable (uint16_t tx_cpid, iwf_ip_addr_t * ip_dst,
        iwf_ip_addr_t * ip_src, uint8_t * index)
{
    uint32_t ip_index = LTE_IP_SRC_IDX_INVALID;
    uint8_t tmp_index = 0xff;

    *index = tmp_index;
    if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
    {
        if(0 != printk_ratelimit())
        {

            printk("\nTRSCONFIG DEBUG:get_gtp_mgmt_trswConfigTable SE_TRACE: data received:\n");
        }
    }
    /*printk("tx_cpid: 0x%x, ip_dst = %d, ip_src = %d\n",
      tx_cpid,
      ip_dst.ip4_addr32,
      ip_src.ip4_addr32); */

    ip_index  = getUserPathIpIndex(ip_src);


    if(LTE_IP_SRC_IDX_INVALID == ip_index)
    {
        return ERR_INVALID_INDEX_IN_LTE_IP_TABLE;
    } 

    for(tmp_index = 0; tmp_index < MAX_SGW_IP_ADDRESSES; tmp_index++)
    {
        //Check for IP address and corresponding CCID (CCID which was assigned by TRSW host)

        if ( ip_is_equal(&Strsw_config_table[tmp_index].uip_dst, ip_dst) &&
                (Strsw_config_table[tmp_index].ip_src_index == ip_index) &&
                (Strsw_config_table[tmp_index].tx_cpid == tx_cpid))
        {
            if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
            {
                if(0 != printk_ratelimit())
                {
                    printk("TRSCONFIG DEBUG:: entry found!\n");
                }
            }
            *index = tmp_index;
            return VTC_OK;
        }
    }
    if(IWF_LOG_LEVEL_TABLES_CONFIG & iwf_log_level)
    {
        if(0 != printk_ratelimit())
        {

            printk("TRSCONFIG DEBUG:: no matching entry found!\n");
        }
    }
    return ERR_NO_MATCHING_ENTRY;
}


uint32_t ipcs_get_gtp_mgmt_trswConfigTable (sIpSicpApiMsg *msg)
{
    uint32_t retVal                  = VTC_OK;
    ip_sicp_api_t        * cfg       = (ip_sicp_api_t *) getCfgMsgPayload(msg);
    vtc_lte_trsw_config_table_t  * conf_data = (vtc_lte_trsw_config_table_t *) &cfg->u.trsw_config_table;
    uint8_t index = 0;

    retVal = get_gtp_mgmt_trswConfigTable(conf_data->tx_cpid, &conf_data->uip_dst, &conf_data->uip_src, &index);
    if(index < 32)
    {
        conf_data->rx_nid       = Strsw_config_table[index].rx_nid;
        conf_data->tx_nid       = Strsw_config_table[index].tx_nid;
        conf_data->rx_cpid      = Strsw_config_table[index].rx_cpid;

        retVal = VTC_OK;
    }
    else
    {
        retVal = ERR_NO_MATCHING_ENTRY;
    }

    return retVal;
}

uint32_t proc_dump_trswConfigTable ( struct seq_file *m)
{

    uint32_t num_connections = 0, i;
    char ip_src_str[40];
    char ip_dst_str[40];

    if (NULL != Strsw_config_table)
    {
        /* only if valid pointer, else we would get a seg fault */
        seq_printf(m,"\nTRSW Config Table for GTP-U management:\n");
        seq_printf(m,"=================================================================================\n");
        seq_printf(m,"entry\t rx_nid\t tx_nid\t rx_cpid\t tx_cpid\t ip_dst                           ip_src                         ip_src_idx\n");
        seq_printf(m,"=====\t ======\t ======\t =======\t =======\t ===============================  =============================  =======\n");
        for (i = 0; i < MAX_SGW_IP_ADDRESSES; i++)
        {
            //Print only valid entries (entry !=0)
            if (!((Strsw_config_table[i].rx_nid  == 0) &&
                        (Strsw_config_table[i].tx_nid  == 0) &&
                        (Strsw_config_table[i].rx_cpid == 0) &&
                        (Strsw_config_table[i].tx_cpid == 0) &&
                        (Strsw_config_table[i].ip_src_index == LTE_IP_SRC_IDX_INVALID ) &&
                        (is_ip_addr_null(&Strsw_config_table[i].uip_dst) == false)))
            {
                if(Strsw_config_table[i].uip_src.version == IPv4)
                {
                    iwf_ip_addr_t ip_src;
                    iwf_ip_addr_t ip_dst;

                    ip_dst.addr_u.ipv4Address.ipa_32 = htonl(Strsw_config_table[i].uip_dst.ip4_addr32);
                    ip_src.addr_u.ipv4Address.ipa_32 = htonl(Strsw_config_table[i].uip_src.ip4_addr32);

                    seq_printf(m,"%d\t 0x%04x\t 0x%04x\t 0x%04x\t 0x%04x\t %-39s\t %-39s\t %d\n", (i+1),
                            Strsw_config_table[i].rx_nid,  Strsw_config_table[i].tx_nid,
                            Strsw_config_table[i].rx_cpid, Strsw_config_table[i].tx_cpid,
                            fzm_enet_inet_ntoa_r(ip_dst.addr_u.ipv4Address, ip_dst_str),
                            fzm_enet_inet_ntoa_r(ip_src.addr_u.ipv4Address, ip_src_str),
                            Strsw_config_table[i].ip_src_index);
                }
                else if (Strsw_config_table[i].uip_src.version == IPv6)
                {
                    iwf_ip_addr_t ip_src;
                    iwf_ip_addr_t ip_dst;

                    ip_dst.addr_u.ipv6Address.ipa_32[0] = htonl(Strsw_config_table[i].uip_dst.ip6_addr32[0]);
                    ip_dst.addr_u.ipv6Address.ipa_32[1] = htonl(Strsw_config_table[i].uip_dst.ip6_addr32[1]);
                    ip_dst.addr_u.ipv6Address.ipa_32[2] = htonl(Strsw_config_table[i].uip_dst.ip6_addr32[2]);
                    ip_dst.addr_u.ipv6Address.ipa_32[3] = htonl(Strsw_config_table[i].uip_dst.ip6_addr32[3]);

                    ip_src.addr_u.ipv6Address.ipa_32[0] = htonl(Strsw_config_table[i].uip_src.ip6_addr32[0]);
                    ip_src.addr_u.ipv6Address.ipa_32[1] = htonl(Strsw_config_table[i].uip_src.ip6_addr32[1]);
                    ip_src.addr_u.ipv6Address.ipa_32[2] = htonl(Strsw_config_table[i].uip_src.ip6_addr32[2]);
                    ip_src.addr_u.ipv6Address.ipa_32[3] = htonl(Strsw_config_table[i].uip_src.ip6_addr32[3]);

                    seq_printf(m,"%d\t 0x%04x\t 0x%04x\t 0x%04x\t 0x%04x\t %-39s\t %-39s\t %d\n", (i+1),
                            Strsw_config_table[i].rx_nid,  Strsw_config_table[i].tx_nid,
                            Strsw_config_table[i].rx_cpid, Strsw_config_table[i].tx_cpid,
                            fzm_enet_inet_ntoa_IPv6_r(ip_dst.addr_u.ipv6Address, ip_dst_str),
                            fzm_enet_inet_ntoa_IPv6_r(ip_src.addr_u.ipv6Address, ip_src_str),
                            Strsw_config_table[i].ip_src_index);

                }
                else
                {
                    //seq_printf(m,"IP version not set !!!\n");
                }

                num_connections++;
            }
        }
        seq_printf(m,"----------- ------ ------- ------- --------------------------------------------\n");
        seq_printf(m,"Total number of connections in TRSW Config Table: %u\n", num_connections);
        seq_printf(m,"---------------------------------------------------------------------------------\n");
    }
    else
    {
        seq_printf(m,"TRSW Config Table for GTP-U management table pointer = NULL\n");
        return VTC_ERR;
    }

    return VTC_OK;
}

